/*   Copyright 2012 Oliver Szymanski & David Tanzer

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.jsxp.framework.webroot.jsxpframework.examples.elements;

import org.jsxp.framework.ElementTemplate;
import org.jsxp.framework.webroot.generated.jsxpframework.examples.elements.IndexXhtmlControllerGenerated;

public class IndexXhtmlController extends IndexXhtmlControllerGenerated {

	@Override
	public void execute() {
		getElementHeadline().setValue("new dynamic headline");
		getElementText().removeElements();
		getElementText().addXmlAsElements("<h2>dynamic headline 2</h2>");
		getElementText().addText(" (from adding of this xml: <h2>dynamic headline 2</h2>)");

		getElementTable().setAttribute("border", "1px");
		final ElementTemplate<Row> templateRow = getElementRow().createTemplate();
		getElementRow().remove();

		final Row row1 = templateRow.createElement();
		row1.getElementCell1().setValue("new row 1 cell 1");
		getElementTable().addElement(row1);

		final Row row2 = templateRow.createElement();
		row2.getElementCell1().setValue("new row 2 cell 1");
		getElementTable().addElement(row2);
	}
}
