/*   Copyright 2012 Oliver Szymanski & David Tanzer

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.jsxp.framework.webroot.jsxpframework.examples.context;

import org.jsxp.framework.Application;
import org.jsxp.framework.Context;
import org.jsxp.framework.webroot.generated.jsxpframework.examples.context.IndexXhtmlControllerGenerated;

public class IndexXhtmlController extends IndexXhtmlControllerGenerated {

	@Override
	public void execute() {
		Context.getContext().addDebugMessage("THIS IS A DEBUG MESSAGE THAT WAS ADDED VIA THE CONTEXT.");
		Context.getContext().addDeveloperWarningMessage("THIS IS A DEVELOPER WARNING THAT WAS ADDED VIA THE CONTEXT.");
		Context.getContext().addFlashErrorMessage("THIS IS A FLASH ERROR MESSAGE THAT WAS ADDED VIA THE CONTEXT.");
		Context.getContext().addFlashWarningMessage("THIS IS A FLASH WARNING MESSAGE THAT WAS ADDED VIA THE CONTEXT.");

		Context.getContext().addFlashInformationMessage("THIS IS A FLASH ERROR MESSAGE THAT WAS ADDED VIA THE CONTEXT.");
		Context.getContext().addFlashInformationMessage("Application is currently in the project stage: "+Application.getApplication().getProjectStage().getName());
		Context.getContext().addFlashInformationMessage("This is the current locale that was returned by the context: "+Context.getContext().getCurrentLocale());
	}
}
