/*   Copyright 2012 Oliver Szymanski & David Tanzer

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.jsxp.framework.webroot.jsxpframework.examples.redirect;

import org.jsxp.framework.Context;
import org.jsxp.framework.webroot.generated.jsxpframework.examples.redirect.RedirectXhtmlControllerGenerated;

public class RedirectXhtmlController extends RedirectXhtmlControllerGenerated {

	private final Input input = new Input();

	@Override
	public void execute() {
		if (input.getRedirectTarget() != null) {
			Context.getContext().redirect(input.getRedirectTarget(), input.isClientSideRedirect(), null);
		}
	}

	@Override
	public Object getInputParameterBean() {
		return input;
	}
}
