/*   Copyright 2012 Oliver Szymanski & David Tanzer

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.jsxp.framework.elementprocessing;

import org.jsxp.framework.ViewController;
import org.jsxp.framework.ViewControllerLifeCycle.LifeCyclePhase;

/**
 * Defines how view resources (for examples used for scripts that are needed by views and have to be
 * included as a link to HTML head) are handled by the jsxp framework. There are different processor
 * implementations for different task. You can implement your own processors and use them.
 */
public interface ElementProcessor {

	/**
	 * Process elements in the rendering view controller. Normally an element processor will be
	 * initialized with references to elements that will be processed during the phase {@link LifeCyclePhase#ELEMENTPROCESSING}.
	 * @param renderViewController
	 */
	public void process(ViewController renderViewController);

}
