/*   Copyright 2012 Oliver Szymanski & David Tanzer

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.jsxp.framework.internal;

/**
 * The Interface ProxyElement. Used only internally by the jsxp framework to get real elements
 * from their corresponding proxy elements. Needed to support different element implementations
 * (e.g. the default DOM-implementation).
 */
public interface ProxyElement {

	/**
	 * Gets the real element.
	 * 
	 * @return the real element
	 */
	public InternalElement getRealElement();
}
