/*   Copyright 2012 Oliver Szymanski & David Tanzer

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.jsxp.framework.webroot.jsxpframework.components.ajax;

import org.jsxp.framework.elementprocessing.processors.HeadLink;
import org.jsxp.framework.elementprocessing.processors.RelativeUri;
import org.jsxp.framework.webroot.generated.jsxpframework.components.ajax.AjaxXhtmlControllerGenerated;

/**
 * Basic view controller to test the framework
 */
public class AjaxXhtmlController extends AjaxXhtmlControllerGenerated {

	@Override
	public void init() {
		// ensure the the ajax script resource will be rendered to head of
		// rendering view, whenever this controller is imported
		addElementProcessor(new HeadLink(getElementAjaxResource(), "ajax.js"));
		addElementProcessor(new RelativeUri(getElementAjaxResource(), "src"));
		addElementProcessor(new HeadLink(getElementFormResource(), "script.js"));
		addElementProcessor(new RelativeUri(getElementFormResource(), "src"));
	}

}
