/*   Copyright 2012 Oliver Szymanski & David Tanzer

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.jsxp.framework.logging;

import java.util.logging.Level;

/**
 * Support additional log levels
 * @author Oliver Szymanski
 *
 */
public class LogLevel extends Level
{

	/**
	 * DEBUG log level
	 */
	public static final Level DEBUG = new LogLevel("DEBUG", 600);

	/**
	 * 
	 */
	private static final long serialVersionUID = 4810733462701196001L;

	/**
	 * Constructor to create additional log level
	 * @param name
	 * @param value
	 */
	protected LogLevel(final String name, final int value)
	{
		super(name, value);
	}

}
