/* DOM Implementation */

/* Fix for IE */
if (!Document.ELEMENT_NODE) {
	  Document.ELEMENT_NODE = 1;
	  Document.ATTRIBUTE_NODE = 2;
	  Document.TEXT_NODE = 3;
	  Document.CDATA_SECTION_NODE = 4;
	  Document.ENTITY_REFERENCE_NODE = 5;
	  Document.ENTITY_NODE = 6;
	  Document.PROCESSING_INSTRUCTION_NODE = 7;
	  Document.COMMENT_NODE = 8;
	  Document.DOCUMENT_NODE = 9;
	  Document.DOCUMENT_TYPE_NODE = 10;
	  Document.DOCUMENT_FRAGMENT_NODE = 11;
	  Document.NOTATION_NODE = 12;
	}

/* Namensraeume */
if (org == null || typeof(org) != "object") { var org = new Object();}
if (org.jsxp == null || typeof(org.jsxp) != "object") { org.jsxp = new Object();}
if (org.jsxp.js == null || typeof(org.jsxp.js) != "object") { org.jsxp.js = new Object();}
if (org.jsxp.js.dom == null || typeof(org.jsxp.js.dom) != "object") { org.jsxp.js.dom = new Object();}

org.jsxp.js = {
	createAJAXSupport: function createAJAXSupport() {
		return new org.jsxp.js.AJAXSupport();
	}
};

org.jsxp.js.dom = {
		/* Fix because of missing DOM-Level 2  "importNode" functionality */
		importNode: function importNode(doc, node, allChildren) {
		  if (node.nodeType == Document.ELEMENT_NODE) {
		  	  var newNode = doc.createElement(node.nodeName);
	        	
		      /* does the node have any attributes to add? */
		  	  if (node.attributes && node.attributes.length > 0) {
		      	for (var i = 0; i < node.attributes.length; i++) {
		        	newNode.setAttributeNS(node.attributes[i].namespaceURI, node.attributes[i].name, node.attributes[i].value);
		        }
		      }
		      
		      /* are we going after children too, and does the node have any? */
		      if (allChildren && node.childNodes &&	node.childNodes.length > 0) {
		    	  for (var j = 0; j < node.childNodes.length; j++) {
		  	    		newNode.appendChild(this.importNode(doc, node.childNodes[j], allChildren));
			      }
		      }
		      return newNode;
		  } 
		  return doc.createTextNode(node.nodeValue);
		}
};

/* "class" AJAXSupport */
org.jsxp.js.AJAXSupport = function() {
	var self = this;
	var ready = true;

	var createXMLHttpRequest = 
		function () {
			try { return new XMLHttpRequest(); } catch(e) {}
			try { return new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {}
			try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch (e) {}
			alert("XMLHttpRequest not supported");
			return null;
		};
		
	this.xmlHttpRequest = createXMLHttpRequest();
	
	this.doRequest = 
	function(method, uri, body, contentType, maxWaitingTime, callbackFunction, updateIds) {
		return this.doRequest(method, uri, null, body, contentType, maxWaitingTime, callbackFunction, updateIds);
	};
	
	this.doRequest = 
	function(method, uri, commandId, body, contentType, maxWaitingTime, callbackFunction, updateIds) {
		 if (!(this.xmlHttpRequest.readyState == 0 || this.xmlHttpRequest.readyState == 4)) {
			 return false;
		 }
		 if (!ready) {
			 alert("do not use this element more than one time to prevent network error");
		 }
		 
		 ready = false;
		
		 this.xmlHttpRequest.open(method, uri, true); // true for asynchronous
		 if (contentType != null) {
			 this.xmlHttpRequest.setRequestHeader('Content-Type', contentType);
		 }
		  
		 // ajax header needed so that jsxp sends back contenttype text/xml
		 this.xmlHttpRequest.setRequestHeader('www.jsxp.org-spec-1.0-partial-request', true);
			
		 if (updateIds != null) {
			 this.xmlHttpRequest.setRequestHeader('www.jsxp.org-spec-1.0-update-ids', updateIds);
		 }	 
		
		 if (commandId != null) {
			 this.xmlHttpRequest.setRequestHeader('www.jsxp.org-spec-1.0-command-id', commandId);
		 }	 
		 
		 this.xmlHttpRequest.onreadystatechange = function() 
		 {
			 self.onResponse(callbackFunction);
		 };
		 
		 if (maxWaitingTime > 0) {
		 var requestTimer = setTimeout(function() {
			 	self.xmlHttpRequest.abort();
			 }, maxWaitingTime);
		 }
		 this.xmlHttpRequest.send(body);
		 return true;
	};

	this.doPostXMLRequest = 
	function (uri, formEncodedBody, maxWaitingTime) {
		return this.doRequest("post", uri, formEncodedBody, 'text/xml', maxWaitingTime,null);
	};

	this.doPostFormRequest = 
	function (uri, formEncodedBody, maxWaitingTime) {
		return this.doRequest("post", uri, formEncodedBody, 'application/x-www-form-urlencoded', maxWaitingTime,null);
	};

	this.doPostRequest = 
	function(uri, body, maxWaitingTime) {
		return this.doRequest("post", uri, body, null, maxWaitingTime,null);
	};

	this.doGetRequest = 
	function(uri, maxWaitingTime) {
		return this.doRequest("get", uri, null, null, maxWaitingTime,null);
	};
	
	this.doSendFormForElementId = 
	function(queryElementRootId, maxWaitingTime, updateIds) {
		if (!org.jsxp.js.form || !org.jsxp.js.form.getFormSupport()) {
			alert("org.jsxp.js.form.FormSupport not initialized");
			return false;
		}
		
		var form = org.jsxp.js.form.getFormSupport().getFormForElementId(queryElementRootId);
		
		return this.doSendForm(form, maxWaitingTime, updateIds)
	}
	
	this.doSendForm = 
		function(queryElementRoot, maxWaitingTime, updateIds) {
			if (!org.jsxp.js.form || !org.jsxp.js.form.getFormSupport()) {
				alert("org.jsxp.js.form.FormSupport not initialized");
				return false;
			}
			
			var form = org.jsxp.js.form.getFormSupport().getFormForElement(queryElementRoot);
			var method = org.jsxp.js.form.getFormSupport().getFormMethod(form);
			var uri = org.jsxp.js.form.getFormSupport().getFormUri(form);
			var body = org.jsxp.js.form.getFormSupport().getFormBody(form);
			var encoding = org.jsxp.js.form.getFormSupport().getFormEnctype(form);
			return this.doRequest(method,uri,body,encoding,maxWaitingTime, null, updateIds);
		}
	
	this.doSendFormUri = 
		function(uri, queryElementRoot, maxWaitingTime, updateIds) {
			if (!org.jsxp.js.form || !org.jsxp.js.form.getFormSupport()) {
				alert("org.jsxp.js.form.FormSupport not initialized");
				return false;
			}
			
			var form = org.jsxp.js.form.getFormSupport().getFormForElement(queryElementRoot);
			var method = org.jsxp.js.form.getFormSupport().getFormMethod(form);
			var body = org.jsxp.js.form.getFormSupport().getFormBody(form);
			var encoding = org.jsxp.js.form.getFormSupport().getFormEnctype(form);
			return this.doRequest(method,uri,body,encoding,maxWaitingTime, null, updateIds);
		}
	
	this.onResponse =
	function (callbackFunction) {
		   if (self.xmlHttpRequest.readyState != 4)  { return; }
		   if (callbackFunction) {
			   callbackFunction(self.xmlHttpRequest);
			   return;
		   }
		   
		   if (self.xmlHttpRequest.status != 200)  {
			     self.onError();
				 return;
		   }
		  
		   var ajaxIdsHeader = self.xmlHttpRequest.getResponseHeader("www.jsxp.org-spec-1.0-update-ids");
		   if (ajaxIdsHeader) {
			   ajaxIdsHeader = ","+ajaxIdsHeader+",";
		   }
		   
		   var ajaxRemoveIdsHeader = self.xmlHttpRequest.getResponseHeader("www.jsxp.org-spec-1.0-remove-ids");
		   if (ajaxRemoveIdsHeader) {
			   ajaxRemoveIdsHeader = ","+ajaxRemoveIdsHeader+",";
		   }
		   var xml = self.xmlHttpRequest.responseXML;
		   if (xml) {
				     var treeWalkerResponse = xml.createTreeWalker(xml, NodeFilter.SHOW_ELEMENT, 
					   null, false);
			   
			   var replaceSrcArray = new Array();
			   var replaceArray = new Array();
			   var addBeforeSrcArray = new Array();
			   var addBeforeArray = new Array();
			   var addAfterSrcArray = new Array();
			   var addAfterArray = new Array();
			   
			   while(treeWalkerResponse.nextNode()) {
				   var currentNode = treeWalkerResponse.currentNode;
				   
				   if (currentNode.hasAttributeNS("http://www.jsxp.org/spec/1.0", "id") 
						  || currentNode.hasAttribute("jsxp:id")) {
					   var id = currentNode.getAttributeNS("http://www.jsxp.org/spec/1.0", "id");
					   if (!id) { id = currentNode.getAttribute("jsxp:id"); }
					   var process = false;
					   var searchId = id;
					   var indexExchange = -1;
					   var indexAssign = -1;
					   var indexAddBefore = -1; 
					   var indexAddAfter = -1; 
					   
					   if (ajaxIdsHeader) { 
						   indexExchange = ajaxIdsHeader.indexOf(","+id+",");
						   indexAssign = ajaxIdsHeader.indexOf(","+id+":=");
						   indexAddBefore = ajaxIdsHeader.indexOf(","+id+"<"); 
						   indexAddAfter = ajaxIdsHeader.indexOf(","+id+">"); 
						   if (indexExchange >= 0) {
							   process = true;
							   searchId = id;
						   } else if (indexAssign >= 0) {
							   process = true;
							   searchId = ajaxIdsHeader.substring(indexAssign+id.length+3, ajaxIdsHeader.indexOf(",", indexAssign+id.length+3));
						   } else if (indexAddBefore >= 0) {
							   process = true; 
							   searchId = ajaxIdsHeader.substring(indexAddBefore+id.length+2, ajaxIdsHeader.indexOf(",", indexAddBefore+id.length+2));
						   } else if (indexAddAfter >= 0) {
							   process = true;
							   searchId = ajaxIdsHeader.substring(indexAddAfter+id.length+2, ajaxIdsHeader.indexOf(",", indexAddAfter+id.length+2));
						   }
					   }  else {
						   process = true;
						   exchange = true;
						   indexExchange = 1;
						   searchId = id;
					   }
					   
					   if (process == true) {
						   var treeWalkerSource = document.createTreeWalker(document, NodeFilter.SHOW_ELEMENT, 
								   null, false);
						   while(treeWalkerSource.nextNode()) {
							   var currentNodeSource = treeWalkerSource.currentNode;
							   if (currentNodeSource.hasAttributeNS("http://www.jsxp.org/spec/1.0", "id")
									   || currentNodeSource.hasAttribute("jsxp:id")) {
								   var idSource = currentNodeSource.getAttributeNS("http://www.jsxp.org/spec/1.0", "id");
								   if (!idSource) {idSource = currentNodeSource.getAttribute("jsxp:id"); }
								   if (searchId == idSource) {
									   var importedNode = org.jsxp.js.dom.importNode(document, currentNode, true);
									   if (indexExchange >= 0 || indexAssign >= 0) {
										   replaceSrcArray.push(currentNodeSource);
										   replaceArray.push(importedNode);
									   } else if (indexAddBefore >= 0) {
										   addBeforeSrcArray.push(currentNodeSource);
										   addBeforeArray.push(importedNode);
									   } else if (indexAddAfter >= 0) {
										   addAfterSrcArray.push(currentNodeSource);
										   addAfterArray.push(importedNode);
									   }
									   break;
								   }
							   }
						   }
					   }
				   }
			   }
			   for (var i=0; i < replaceSrcArray.length; i++ )
			   {
				   replaceSrcArray[i].parentNode.replaceChild(replaceArray[i], replaceSrcArray[i]);
			   }
			   for (var i=0; i < addBeforeSrcArray.length; i++ )
			   {
				   addBeforeSrcArray[i].parentNode.insertBefore(addBeforeArray[i], addBeforeSrcArray[i]);
			   }
			   for (var i=0; i < addAfterSrcArray.length; i++ )
			   {
				   addAfterSrcArray[i].parentNode.insertBefore(addAfterArray[i], addAfterSrcArray[i]);
				   addAfterSrcArray[i].parentNode.removeChild(addAfterSrcArray[i]);
				   addAfterArray[i].parentNode.insertBefore(addAfterSrcArray[i], addAfterArray[i]);
			   }
		   }
		   
		   // remove
		   if (ajaxRemoveIdsHeader) {
			   treeWalkerSource = document.createTreeWalker(document, NodeFilter.SHOW_ELEMENT, 
					   null, false);
			   var removeArray = new Array();
			   while(treeWalkerSource.nextNode()) {
				   var removeNodeSource = treeWalkerSource.currentNode;
				   if (removeNodeSource.hasAttributeNS("http://www.jsxp.org/spec/1.0", "id")
						   || removeNodeSource.hasAttribute("jsxp:id")) {
					   var idRemoveSource = removeNodeSource.getAttributeNS("http://www.jsxp.org/spec/1.0", "id");
					   if (!idRemoveSource) { idRemoveSource = removeNodeSource.getAttribute("jsxp:id"); }
					   if (ajaxRemoveIdsHeader && ajaxRemoveIdsHeader.indexOf(","+idRemoveSource+",")>=0) {
						   removeArray.push(removeNodeSource);
					   }
				   }
			   }
			   for (var j = 0; j < removeArray.length; j++) {
				   removeArray[j].parentNode.removeChild(removeArray[j]);
			   }
		   }
	};

	this.onError =
	function() {
		if (self.xmlHttpRequest.status != 0) {
			var text = "";
			if (self.xmlHttpRequest.statusText) {
				text = " - " + self.xmlHttpRequest.statusText;
			}
			alert('error: '+self.xmlHttpRequest.status + text);
		}
	};
};






 